local GetWorld = GLOBAL.GetWorld
local GetClock = GLOBAL.GetClock

Assets = { Asset("ANIM", "anim/moon_waning_phases.zip"), }

local moonmode   = GetModConfigData("moonmode")
local waningmode = GetModConfigData("waningmode")

local function UIClockPostInit(self)
    
    if moonmode == "always" then
    
        self:ShowMoon()
        
        self.inst:ListenForEvent( "daytime", function(inst, data) 
            self:ShowMoon()
        end, GetWorld())
        
    elseif moonmode == "dusknight" then
    
        if GetClock():IsDusk() then
            self:ShowMoon()
        end
        
        self.inst:ListenForEvent( "dusktime", function(inst, data) 
            self:ShowMoon()
        end, GetWorld())
    
    end
    
    function self:ShowMoon()
        local mp = GetClock():GetMoonPhase()
        local moon_syms = 
        {
            new="moon_new",
            quarter="moon_quarter",
            half="moon_half",
            threequarter="moon_three_quarter",
            full="moon_full",
            waningthreequarter="moon_three_quarter",
            waninghalf="moon_half",
            waningquarter="moon_quarter",
        }
        if not ( string.find(mp, "waning") and waningmode ) then
            self.moonanim:GetAnimState():OverrideSymbol("swap_moon", "moon_phases", moon_syms[mp] or "moon_full")
        else
            self.moonanim:GetAnimState():OverrideSymbol("swap_moon", "moon_waning_phases", moon_syms[mp] or "moon_full")
        end
        self.moonanim:GetAnimState():PlayAnimation("trans_out") 
        self.moonanim:GetAnimState():PushAnimation("idle", true) 
    end
    
end

local function ClockComponentPostInit(self)
    
    local moonphases = 
    {
        "new",
        "quarter",
        "half",
        "threequarter",
        "full",
        "waningthreequarter",
        "waninghalf",
        "waningquarter",
    }
    
    function self:GetMoonPhase()
        local phaselength = 2
        local n = #moonphases
        
        local idx = math.floor( math.floor(self.numcycles/phaselength) % n )
        
        return moonphases[idx+1]
    end
    
end

AddClassPostConstruct("widgets/uiclock", UIClockPostInit)
if waningmode then AddComponentPostInit("clock", ClockComponentPostInit) end